/*
 * Fachlicher Schlüssel für JPA Entität
 */
package de.ivu.elect.business.stimmeingabe.entity;

import de.ivu.elect.jee.faces.Messages;
import java.util.function.Function;

@javax.enterprise.inject.Vetoed
public class StimmeingabePlausiKonfigurationTK
implements de.ivu.elect.jee.entity.tk.EntityTK, java.io.Serializable
  {

  private static final long serialVersionUID = 1L;

  private final int hashCode;

    protected final de.ivu.elect.business.stimmeingabe.entity.StimmeingabePlausiErgebniseingangsart ergebniseingangsart;
    public de.ivu.elect.business.stimmeingabe.entity.StimmeingabePlausiErgebniseingangsart getErgebniseingangsart(){
      return ergebniseingangsart;
    }
    protected final de.ivu.elect.business.stimmeingabe.entity.StimmeingabePlausiGebietsart gebietsart;
    public de.ivu.elect.business.stimmeingabe.entity.StimmeingabePlausiGebietsart getGebietsart(){
      return gebietsart;
    }
    protected final de.ivu.elect.business.stimmeingabe.entity.StimmeingabePlausiTyp typ;
    public de.ivu.elect.business.stimmeingabe.entity.StimmeingabePlausiTyp getTyp(){
      return typ;
    }
  protected final de.ivu.elect.business.wahl.entity.WahlTK wahlTK;
    public de.ivu.elect.business.wahl.entity.WahlTK getWahlTK(){
      return wahlTK;
    }

  public StimmeingabePlausiKonfigurationTK(
de.ivu.elect.business.stimmeingabe.entity.StimmeingabePlausiErgebniseingangsart ergebniseingangsart
, de.ivu.elect.business.stimmeingabe.entity.StimmeingabePlausiGebietsart gebietsart
, de.ivu.elect.business.stimmeingabe.entity.StimmeingabePlausiTyp typ
,   de.ivu.elect.business.wahl.entity.WahlTK wahlTK
  ) {
    super();


      this.ergebniseingangsart = ergebniseingangsart;
      this.gebietsart = gebietsart;
      this.typ = typ;
        this.wahlTK = wahlTK;
  
hashCode = calculateHashCode();
  }

  @Override
  public int hashCode(){
    return hashCode;
  }


  protected int calculateHashCode() {
        int result = 1;
    
    
                    result = result + ((ergebniseingangsart == null) ? 0 : ergebniseingangsart.hashCode());
                    result = result + ((gebietsart == null) ? 0 : gebietsart.hashCode());
                    result = result + ((typ == null) ? 0 : typ.hashCode());
        
                    result = result + ((wahlTK == null) ? 0 : wahlTK.hashCode());
            
    return result;
  }

  @Override
  public boolean equals(Object obj) {
    if (this == obj) {
      return true;
    }

    if (obj == null) {
      return false;
    }

    if (hashCode()!=obj.hashCode()) {
      return false;
    }


            
    if (getClass() != obj.getClass()) {
      if (!(obj instanceof StimmeingabePlausiKonfigurationTK)) {
        return false;
      }

      if (!obj.getClass().isInstance(this)) {
        return obj.equals(this); // equals-Methode aus speziellerer Klasse verwenden
      }

    }

        StimmeingabePlausiKonfigurationTK other = (StimmeingabePlausiKonfigurationTK) obj;

                if (ergebniseingangsart == null) {
          if (other.ergebniseingangsart != null) {
            return false;
          }
        } else if (!ergebniseingangsart.equals(other.ergebniseingangsart)) {
          return false;
        }
                if (gebietsart == null) {
          if (other.gebietsart != null) {
            return false;
          }
        } else if (!gebietsart.equals(other.gebietsart)) {
          return false;
        }
                if (typ == null) {
          if (other.typ != null) {
            return false;
          }
        } else if (!typ.equals(other.typ)) {
          return false;
        }
        
                if (wahlTK == null) {
          if (other.wahlTK != null) {
            return false;
          }
        } else if (!wahlTK.equals(other.wahlTK)) {
          return false;
        }
            return true;
    
  }

  protected boolean hatAttribute() {
        return true;
      }

  @Override
  public String getEntityMessageKey() {
    return StimmeingabePlausiKonfigurationConstants.MESSAGE_KEY_ENTITY_EINZAHL;
  }

  @Override
  public java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> getAllEntityFieldValues() {
    java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> result = new java.util.ArrayList<>();

    result.addAll(getEntityFieldValuesForEntity());
    result.addAll(wahlTK.getAllEntityFieldValues());
    return result;
  }

  @Override
  public java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> getEntityFieldValuesForEntity() {
            java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> result = new java.util.ArrayList<>();

                    result.add(new de.ivu.elect.jee.entity.tk.EntityFieldValue(StimmeingabePlausiKonfigurationConstants.MESSAGE_KEY_ENTITY_EINZAHL, StimmeingabePlausiKonfigurationConstants.MESSAGE_KEY_PLAUSI_ERGEBNISART_EINZAHL, ergebniseingangsart));
                    result.add(new de.ivu.elect.jee.entity.tk.EntityFieldValue(StimmeingabePlausiKonfigurationConstants.MESSAGE_KEY_ENTITY_EINZAHL, StimmeingabePlausiKonfigurationConstants.MESSAGE_KEY_PLAUSI_GEBIETSART_EINZAHL, gebietsart));
                    result.add(new de.ivu.elect.jee.entity.tk.EntityFieldValue(StimmeingabePlausiKonfigurationConstants.MESSAGE_KEY_ENTITY_EINZAHL, StimmeingabePlausiKonfigurationConstants.MESSAGE_KEY_STIMMEINGABE_PLAUSI_TYP_EINZAHL, typ));
        
        return result;
      }


            @Override
            public String toString() {
            return "StimmeingabePlausiKonfigurationTK[" + toStringParameter() + "]";
            }



            protected String toStringParameter() {
            String result = ""

                                        +"ergebniseingangsart="+ergebniseingangsart
                            +", gebietsart="+gebietsart
                            +", typ="+typ
                                        +", wahlTK="+wahlTK
            
            ;
                            return result;
            
            }

  @Override
  public String toStringLokalisiert(Messages messages) {
    return messages.getMessageForMessageKey(getEntityMessageKey()) + " ["
            + toStringLokalisiertFields(messages)
            + "]"
            ;
   }

            protected String toStringLokalisiertFields(Messages messages) {
        return ""
                                      + messages.getMessageForMessageKey(StimmeingabePlausiKonfigurationConstants.MESSAGE_KEY_PLAUSI_ERGEBNISART_EINZAHL) + "=" + ergebniseingangsart
                          + ", " + messages.getMessageForMessageKey(StimmeingabePlausiKonfigurationConstants.MESSAGE_KEY_PLAUSI_GEBIETSART_EINZAHL) + "=" + gebietsart
                          + ", " + messages.getMessageForMessageKey(StimmeingabePlausiKonfigurationConstants.MESSAGE_KEY_STIMMEINGABE_PLAUSI_TYP_EINZAHL) + "=" + typ
                                      + ", " +  toStringLokalisiert(wahlTK, messages)
                                 ;
      }


            private String toStringLokalisiert(de.ivu.elect.jee.entity.tk.EntityTK entityTK, Messages messages) {
                if (entityTK != null) {
                    return entityTK.toStringLokalisiert(messages);
                }
                return null;
            }

            public static <E extends StimmeingabePlausiKonfiguration> java.util.Map<StimmeingabePlausiKonfigurationTK, E> mappeStimmeingabePlausiKonfigurationNachTK(java.util.Collection<E> entities) {
                return entities.stream().collect(java.util.stream.Collectors.toMap(StimmeingabePlausiKonfiguration::getStimmeingabePlausiKonfigurationTK, Function.<E>identity(), (u,v)-> v));
                }


                public static Function<StimmeingabePlausiKonfiguration, StimmeingabePlausiKonfigurationTK> getStimmeingabePlausiKonfigurationToTKFunction() {
                return StimmeingabePlausiKonfiguration::getStimmeingabePlausiKonfigurationTK;
                }

}
